-- VehicleIncreaseRpmForageWagon
-- Spezi fr eine erhhte Drezahl beim Arbeiten mit einem Ladewagen oder beim Abladen des Ladewagen.

-- Datum: 15.03.2014
-- Autor: Ifko[nator] alex2009 meyer123

-- Edit: 19.04.2014
-- Edit by: Ifko[nator]
-- Gendert wurde: Ladewagen schaltet sich nun automatisch beim Abladen ein. Dadurch konnte die LUA um ein vielfaches verkleinert werden

VehicleIncreaseRpmForageWagon = {};

function VehicleIncreaseRpmForageWagon.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(ForageWagon, specializations);
end;

function VehicleIncreaseRpmForageWagon:load(xmlFile)
	self.modDir_VehicleIncreaseRpmForageWagon = self.baseDirectory;
	self.setVehicleIncreaseRpmForageWagon = SpecializationUtil.callSpecializationsFunction("setVehicleIncreaseRpmForageWagon");
end;

function VehicleIncreaseRpmForageWagon:delete()
end;

function VehicleIncreaseRpmForageWagon:mouseEvent(posX, posY, isDown, isUp, button)
end;

function VehicleIncreaseRpmForageWagon:keyEvent(unicode, sym, modifier, isDown)
end;

function VehicleIncreaseRpmForageWagon:update(dt)
	if self:getIsActive() then
		if self.isTurnedOn then
			if self.attacherVehicle ~= nil then
				if self.attacherVehicle.motor ~= nil then
					self:setVehicleIncreaseRpmForageWagon(dt, true);
				end;
			end;
		else
			self:setVehicleIncreaseRpmForageWagon(nil, false);
		end;
	end;
end;

function VehicleIncreaseRpmForageWagon:updateTick(dt)
end;

function VehicleIncreaseRpmForageWagon:setVehicleIncreaseRpmForageWagon(dt, isActive)
	if self.attacherVehicle ~= nil and self.saveMinimumRpm ~= 0 and self.attacherVehicle.motor ~= nil then
		if dt ~= nil then
			if isActive == true then
				self.attacherVehicle.motor.minRpm = math.max(self.attacherVehicle.motor.minRpm-(dt*2), -1800);
			else
				self.attacherVehicle.motor.minRpm = math.min(self.attacherVehicle.motor.minRpm+(dt*5), self.saveMinimumRpm);
			end;
		else
			self.attacherVehicle.motor.minRpm = self.saveMinimumRpm;
		end;
	end;
end;

function VehicleIncreaseRpmForageWagon:onAttach(attacherVehicle)
	self.attacherVehicle = attacherVehicle;
	if self.attacherVehicleCopy1 == nil then
		self.attacherVehicleCopy1 = self.attacherVehicle;
	end;
	if self.attacherVehicle.motor ~= nil then
		self.saveMinimumRpm = self.attacherVehicle.motor.minRpm;
	else
		if self.attacherVehicle.saveMinRpm ~= nil then
			self.saveMinimumRpm = self.attacherVehicle.saveMinimumRpm;
		else
			self.attacherVehicle.saveMinimumRpm  = 100;
		end;
	end;
end;

function VehicleIncreaseRpmForageWagon:onDetach()
	for k, steerable in pairs(g_currentMission.steerables) do
		if self.attacherVehicleCopy1 == steerable then
			steerable.motor.minRpm = self.saveMinimumRpm;
			self.attacherVehicleCopy1 = nil;
		end;
	end;
end;

function VehicleIncreaseRpmForageWagon:onStartTip(currentTipTrigger, noEventSend)
	self:setIsTurnedOn(true);
end;

function VehicleIncreaseRpmForageWagon:onEndTip(noEventSend)
	self:setIsTurnedOn(false);
end;

function VehicleIncreaseRpmForageWagon:setIsTurnedOn(isTurnedOn, noEventSend)
end;

function VehicleIncreaseRpmForageWagon:draw()
end